capabilities:
  - id: 100
    name: "IFCconvertor"
    description: "converts ifc to some json"
    container:
      name: "ifc-convertor"
      image:
        name: "registry.ids.smart-connected.nl/workflow-test-app"
        tag: latest
      ports:
        - "8080"
    nodes:
      - name: IFCInput
        mandatory: true
        schema: IFC2X3
        dataType: IFC
        stepType: INPUT
        transferType: DIRECT
        # transferType: httpReference
        # transferType: filePointer
      - name: JSONOutput
        mandatory: true
        schema: fileReference
        dataType: json
        stepType: OUTPUT
        transferType: DIRECT
  - id: 200
    name: "JSONconvertor"
    description: "converts json to xml"
    container:
      name: "json-convertor"
      image:
        name: "registry.ids.smart-connected.nl/workflow-test-app"
        tag: latest
      ports:
        - "8080"
    nodes:
      - name: JSONInputA
        mandatory: true
        schema: fileReference
        dataType: json
        stepType: INPUT
        transferType: DIRECT
      - name: JSONInputB
        mandatory: true
        schema: fileReference
        dataType: json
        stepType: INPUT
        transferType: DIRECT
      - name: XMLOutput
        mandatory: true
        schema: fileReference
        dataType: xml
        stepType: OUTPUT
        transferType: DIRECT
  - id: 300
    name: "Aggregator"
    description: "aggregates xml and json to another json file"
    container:
      name: "aggregator"
      image:
        name: "registry.ids.smart-connected.nl/workflow-test-app"
        tag: latest
      ports:
        - "8080"
    nodes:
      - name: JSONInput
        mandatory: true
        schema: fileReference
        dataType: json
        stepType: INPUT
      - name: XMLInput
        mandatory: true
        schema: fileReference
        dataType: xml
        stepType: INPUT
      - name: JSONOutput
        mandatory: true
        schema: fileReference
        dataType: json
        stepType: OUTPUT

workflows:
  - id: 1
    name: testRun
    invocationFlowMaps:
      - invocation:
          - name: IFCWindowParser
            capabilityId: 100
            nodes:
              - name: IFCInput
              - name: JSONOutput
          - name: IFCDoorParser
            capabilityId: 100
            nodes:
              - name: IFCInput
              - name: JSONOutput
          - name: IFCWallParser
            capabilityId: 100
            nodes:
              - name: IFCInput
              - name: JSONOutput
          - name: JSONConvertor
            capabilityId: 200
            nodes:
              - name: JSONInputA
                requiredNode:
                  invocation: IFCWindowParser
                  node: JSONOutput
              - name: JSONInputB
                requiredNode:
                  invocation: IFCDoorParser
                  node: JSONOutput
              - name: XMLOutput
          - name: Aggregator
            capabilityId: 300
            nodes:
              - name: JSONInput
                requiredNode:
                  invocation: IFCWallParser
                  node: JSONOutput
              - name: XMLInput
                requiredNode:
                  invocation: JSONConvertor
                  node: XMLOutput
              - name: JSONOutput
